DIMcode% 1024:FORopt%=0TO2STEP2:P%=code%:[opt opt%
REM\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
REM >>>>  Heap Sort (HS)                                                   >>>>
REM//////////////////////////////////////////////////// Alain Brobecker //////
REM           IN  - r0=adress of table to sort
REM                 r1=N=nb of values to sort
REM           OUT - Sorts the table from lowest to greatest and kills r0-r9

REMAt first create the heap so that each father is bigger than both sons.
.HeapSort
  movS      r3,r1,asr #1            ;r3=counter=int(N/2)
  movLE     pc,r14                  ;quit if N<2
REMTranslate table so that it is indexed by 1..N instead of 0..N-1, and at
REMthe same time get a second pointer on tab(.+1) which will prove usefull.
  sub       r2,r0,#4                ;r2 points on tab(.), r0 on tab(.+1)
.HS_MkHeapOne
  mov       r4,r3                   ;r4=father
  ldr       r9,[r2,r3,lsl #2]       ;r9=tab(counter)
  add       r5,r3,r3                ;r5=l, points on left son
  cmp       r5,r1                   ;flags=l-N
  bGT       HS_MkHeapNext
  mov       r6,r9                   ;r6=tab(father)
.HS_MkHeapDescentOne
REMWhen current elt has two sons (ie l<N), we make r5 point on biggest one.
  ldr       r7,[r2,r5,lsl #2]       ;r7=tab(l)
  ldrMI     r8,[r0,r5,lsl #2]       ;if l<N then r8=tab(l+1)
  cmpMI     r7,r8                   ;  flags=tab(l)-tab(l+1)
  addMI     r5,r5,#1                ;  and r5=l+1 if tab(l+1)>tab(l)
  movMI     r7,r8
  cmp       r7,r6                   ;flags=tab(l)-tab(father)
  bMI       HS_MkHeapOneHeaped
REMIf we are here, tab(current) is smaller than both sons, we exchange him with
REMhis biggest son in order to preserve the heap structure.
  str       r7,[r2,r4,lsl #2]       ;tab(father)=tab(l)
  mov       r4,r5                   ;father=l
  mov       r5,r5,lsl #1            ;l=2*l
  cmp       r5,r1                   ;Continue?
  bLE       HS_MkHeapDescentOne
.HS_MkHeapOneHeaped
  str       r9,[r2,r4,lsl #2]       ;tab(father)=tab(counter)
.HS_MkHeapNext
 subS r3,r3,#1:bNE HS_MkHeapOne
REMNow we sort the heap by exchanging elts 1 and N, then we descend the new
REMroot in order to have a new heap of size N-1. And we start again on it.
  sub       r1,r1,#1                ;N-=1
.HS_SortHeapOne
  mov       r3,#1                   ;r3=counter
  ldr       r5,[r2,r3,lsl #2]       ;Load tab(1)
  ldr       r4,[r0,r1,lsl #2]       ;Load tab(N+1)=T
  str       r5,[r0,r1,lsl #2]       ;tab(N+1)=tab(1)
REMNow we make T go down.
  add       r5,r3,r3                ;r5=l, points on left son
  cmp       r5,r1                   ;flags=l-N
  bGT       HS_SortHeapNext
.HS_SortHeapDescent
REMWhen current elt has two sons (ie l<N), we make r5 point on biggest one.
  ldr       r7,[r2,r5,lsl #2]       ;r7=tab(l)
  ldrMI     r8,[r0,r5,lsl #2]       ;if l<N then r8=tab(l+1)
  cmpMI     r7,r8                   ;  flags=tab(l)-tab(l+1)
  addMI     r5,r5,#1                ;  and r5=l+1 if tab(l+1)>tab(l)
  movMI     r7,r8
  cmp       r7,r4                   ;flags=tab(l)-T
  bMI       HS_SortHeapNext
REMIf we are here, tab(current) is smaller than both sons, we exchange him with
REMhis biggest son in order to preserve the heap structure.
  str       r7,[r2,r3,lsl #2]       ;tab(current)=tab(l)
  mov       r3,r5                   ;current=l
  mov       r5,r5,lsl #1            ;l=2*l
  cmp       r5,r1                   ;continue as long as l<N
  bLT       HS_SortHeapDescent
.HS_SortHeapNext
  str       r4,[r2,r3,lsl #2]       ;tab(current)=T
 subS r1,r1,#1:bNE HS_SortHeapOne
  mov       pc,r14
]:NEXTopt%:PRINTP%-code%;" bytes"

B%=1<<6:DIMA% B%*4
FORc%=0TOB%-1:A%!(c%*4)=RND(256):PRINT;" ";A%!(c%*4);:NEXT:PRINT
CALLHeapSort
FORc%=0TOB%-1:PRINT;" ";A%!(c%*4);:NEXT:PRINT
END
