REM>zprint
REM1999oct31 - Alain Brobecker
REMPrints a Znumber in decimal format. This is part of SockZ v0.02b.

OS_Write0 = 2

DIMasm% 1024:FORopt%=0TO2STEP2:P%=asm%:[opt opt%

REMUse basic to set up Zstack and execution stack
.Test
  stmfd     r13!,{r0-r12,r14}
  adr       r9,ExecutionStack
  str       r13,[r9],#4
  mov       r8,#1                   ;One elt in stack
  adr       r10,TopOfZStack
 b zprint
.OneInstruction
  ldr       r13,[r9,#-4]!
  ldmfd     r13!,{r0-12,pc}^

REMThis is the free space in stack
.ExecutionStack:]:P%+=256:[opt opt%
REMZnumber format (note that 0 is encoded with N=1 and sign=0)
REM  1 long  29 bits = N = number of longs
REM           2 bits = 0 (for accessing longs easily)
REM           1 bit  = sign (0=positive, 1=negative)
REM  N longs = the number itself (lower values first)
.TopOfZStack
  dcd       (2<<3)+0
  dcd       &EECD8000:dcd &1437E

REMr8 =Size of Zstack
REMr9 =execution stack pointer
REMr10=Zstack pointer
REMr11=adress of Hash Table
REMr12=adress in SockZ code

REM***************************
REM****  Print a ZNumber  ****
REM***************************
REMMaybe the div10 can be made a bit faster, because when the 4 bits = %1010
REMwe know we can shift 4 bits at a time. So with a probability of 1/16, we can
REMavoid 4 times the loop (but this would need bEQ with proba 15/16).
REMMoreover, we can perform a div by 5=%101 instead, and then the probas would
REMbe 1/8 for avoiding 3 times the loop and 7/8 (better?). But of course it is
REMharder to do.

.zprint_Temp            dcb "zzzz"

.zprint
  subS      r8,r8,#1
;  bLT       ArgumentsError
  ldr       r3,[r10],#4             ;r3=len|sgn of source
  mov       r1,r10                  ;r1=ptr to quotient
  add       r10,r10,r3,lsr #1       ;r10 points after source
  mov       r0,r10                  ;r0=ptr to source
  sub       r2,r1,r3,lsr #1         ;r2 points on string
;Make sure we have at least 10*len+1 (+1 if negative) bytes more for string
;(when sgn is set the sign byte is counted gratuitously ;).
  sub       r4,r2,r3                ;r4=end of string-8*len-sgn
  sub       r4,r4,r3,lsr #2         ;r4-=2*len
  sub       r4,r4,#1                ;r4-=1 (for the null terminator)
  cmp       r4,r9
;  bLE       MemoryError
  mov       r4,#0
  strB      r4,[r2,#-1]!            ;Put the null terminator

  str       r12,zprint_Temp

REMIN  r0=ptr to source to divide by 10
REM    r3=len of source | sgn
REM    r1=ptr to space for quotient
REM    r2=ptr to string (ie for the rest)
REMOut r?=len of quotient | sgn
REMr4|r5=longs of source
REMr6=quotient
REMr7=1<<?
.zprint_OneDiv
  mov       r12,r0
  mov       r13,r1
  mov       r14,r3,lsr #3           ;r14=len
  ldr       r4,[r12,#-4]!           ;Load first long of source
  cmp       r4,#10
  bCC       zprint_FirstLongBelow10
  mvn       r6,#2                   ;r6=-3, will contain NbBits for r4
  mov       r5,r4
]:FORc%=4TO1STEP-1:d%=2^c%:[opt opt%
  cmp       r5,#1<<d%
  addCS     r6,r6,#d%
  movCS     r5,r5,lsr #d%
]:NEXTc%:[opt opt%
  cmp       r5,#2
  addCS     r6,r6,#1
  rsb       r5,r6,#32               ;Shift [r4|r5] to have only 4 bits in r4
  mov       r5,r4,lsl r5
  mov       r4,r4,lsr r6
  mov       r7,#1
  mov       r7,r7,lsl r6            ;Current bit for quotient
  mov       r6,#0                   ;Quotient
 b zprint_CompareWith10

.zprint_DivOneBit
  movS      r5,r5,lsl #1            ;Shift both longs
  adc       r4,r4,r4
.zprint_CompareWith10
  cmp       r4,#10                  ;r4>10?
  subGE     r4,r4,#10               ;Then r4-=10
  addGE     r6,r6,r7                ;  and quotient+=current bit
  movS      r7,r7,lsr #1            ;next current bit
 bNE zprint_DivOneBit
  str       r6,[r13,#-4]!           ;Save quotient
  subS      r14,r14,#1
  ldrNE     r5,[r12,#-4]!
  movNE     r7,#1<<31
  movNE     r6,#0
 bNE zprint_DivOneBit
  add       r4,r4,#ASC"0"
  strB      r4,[r2,#-1]!            ;Save rest
  sub       r0,r0,r1                ;Swap r0 and r1
  add       r1,r0,r1
  sub       r0,r1,r0
 b zprint_OneDiv

.zprint_FirstLongBelow10
  subS      r14,r14,#1              ;len-=1
  bEQ       zprint_NoMoreDivs       ;If len=1 then stop the process
  sub       r3,r3,#1<<3             ;len-=1 (for the quotient)
  ldr       r5,[r12,#-4]!           ;load 2nd long
  mov       r6,#0
  mov       r7,#1<<31
 b zprint_DivOneBit

.zprint_NoMoreDivs
  add       r4,r4,#ASC"0"
  strB      r4,[r2,#-1]!            ;Save rest
  tst       r3,#1
  movNE     r4,#ASC"-"
  strNEB    r4,[r2,#-1]!
  mov       r0,r2
  swi       OS_Write0
  ldr       r12,zprint_Temp

 b OneInstruction

]:PRINT"Pass ";opt%/2;": ";P%-asm%;" bytes":NEXT
CALLTest
END
